/* 
 * Copyright (C) 2007-2019 Daniel Manrique-Vallier
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef _R_LCM_EDIMP_H
#define _R_LCM_EDIMP_H
#include "R.h"
#include "Rinternals.h"
#include "R_ext/Utils.h"
extern "C"{
//mask_type: 0: No error; 1: all of them; 2: Only inconsistent
//SEXP R_Create_Lcm_EdImp(SEXP x_flat, SEXP J, SEXP n, SEXP ZeroMC_flat, SEXP nZeroMC, SEXP levels,
//						  SEXP K, SEXP Nmis_max, SEXP a_alpha, SEXP b_alpha, 
//						  SEXP a_error, SEXP b_error, SEXP mask_type, SEXP len_buffer, SEXP subsamp);
SEXP R_Create_Lcm_EdImp2(
    SEXP J, SEXP Idata, SEXP Izeros, SEXP x, SEXP ZeroMC_IJ_original, SEXP levelsJ, 
    SEXP K, SEXP Nmis_max, SEXP a_alpha, SEXP b_alpha, SEXP a_error, SEXP b_error, 
		SEXP mask_type,	SEXP len_buffer, SEXP subsamp);
SEXP R_get_imputed_x_Lcm_EdImp(SEXP p);
SEXP R_get_detectable_errors(SEXP p);

}

#include "daniel2/Model_Environ.h"
#include "CData_DM_MCZ.h"
//#include "CLcm_Bay_Reg_MCZ.h"
#include "CLcm_EdImp_Freq.h"

//Classes for this sampler.
typedef CData_DM_MCZ D;
typedef CLcm_EdImp_Freq M;
typedef CParams_Lcm_EdImp_Freq P;
//ORIGINAL <-------
//typedef CLcm_EdImp M;
//typedef CParams_Lcm_EdImp P;

//template definition
class Lcm_EdImp_Environ : public CModel_Environ_Simple<D, M, P>{
public:
	typedef CModel_Environ_Simple<D, M, P> mit_t;
	Lcm_EdImp_Environ(D* data, P* par, int len_buffer, int subsamp=1, bool del_objects=true) 
			:	mit_t(data, par, len_buffer, subsamp, del_objects){
	}
	~Lcm_EdImp_Environ(){
	}
	void get_current_imputed_x(int *x_raw_imputed){
	    //copies the current imputed dataset (for generating multiply imputed datasets)
		//This is a way of not having to include x in the tracing thing.
		//This is to optimize memory usage.
	    std::copy(this->par->xIJ[0], this->par->xIJ[0] + this->par->n * this->par->J, x_raw_imputed);
	}
	int get_raw_dataset_length(){
		return(this->par->n * this->par->J);
	}
protected:
	void Other_Tracing_Options(){
	}
	void Other_Updating_Options(){
		R_CheckUserInterrupt();
		//DAN_PRINTF("\riteration = %d       ", this->iteration + 1);
	}
};



#endif
