require(editrules)
setwd('c:/Data/Daniel4/Projects/LCM_EdImp/Tests/')
source('functions_for_tests.R')
source('c:/Data/Daniel4/progs/R_Projects/GeneralCode/ArrayUtils.R')
source('c:/Data/Daniel4/progs/R_Projects/LCM_EdImp2/Lcm_EdImp2.R', chdir=T)
source('c:/Data/Daniel4/progs/R_Projects/LCM_EdImp/MZC.R', chdir=T)


load('../../LCM_Impute/Tests/NY_2000_5pct.RData')


#Obtain a subsample from Basic_Tests2.R
test_samples <- fn_subsample_w_contamination(dat_proc, ssize = 1000, trials = 1, cont_rate=rep(0.4,10))
#save(test_samples, file = paste('c:/Data/Datasets/500_subs_cont_', format(Sys.time(), "%Y%M%d_%H%M"), '.RData',sep=''))
#test_samples <- fn_subsample_w_contamination(dat_proc, ssize = 5000, trials = 500, cont_rate=rep(0.4,10))
save(test_samples, file = paste('c:/Data/Datasets/500_subs_5000_cont_', format(Sys.time(), "%Y%M%d_%H%M"), '.RData',sep=''))

load('c:/Data//Datasets/100_subs_cont_20144326_1143.RData')
test_samples$population

ssize <- 1000
n <- NROW(dat_proc)
actual <- sam_stat(dat_proc, m_way=3)
subs <- dat_proc[sample(1:n, replace = TRUE, size = ssize),]

#create contaminated dataset
cont <- fn_contaminate(orig=subs, err_rate=rep (0.4, 10))

#Localize errors using FH approach
E <- fn_Create_Edit_Rules(MCZ)
#ve <- violatedEdits(E, cont$result)
el <- localizeErrors(E, cont$result)
fp_fn(cont$mask, el$adapt)

######
#Impute 
#a)Fellegi Holt
FH_imp <- lcm_Imput_Generator$new(x=fn_blank_mask(dataset=cont$result, mask=el$adapt),ZeroMC=MCZ, K=20, Nmis_max=100000, a_alpha=0.25, b_alpha=0.25, 
                                  len_buffer=10000, subsamp=10)
#b)Joint
joint_weak <- lcm_EdImp_generator$new(x=cont$result,ZeroMC=MCZ, K=20, Nmis_max=100000, a_alpha=0.25, b_alpha=0.25, 
                               a_error = 1, b_error = 1,
                               mask_type = 1,
                               len_buffer=10000, subsamp=10)
joint_strong <- lcm_EdImp_generator$new(x=cont$result,ZeroMC=MCZ, K=20, Nmis_max=100000, a_alpha=0.25, b_alpha=0.25, 
                                      a_error = 1, b_error = 1000*10,
                                      mask_type = 1,
                                      len_buffer=10000, subsamp=10)
joint_weak$Set_Trace('epsilon')
joint_strong$Set_Trace('epsilon')

joint_weak$Update(10000)
joint_strong$Update(10000)

x11(10,5); par(mfrow = c(1,2))
plot(density(joint_weak$Get_Trace('epsilon')), main = 'with Beta(1,1) prior', xlab = expression(epsilon), ylab = 'Posterior Density')
plot(density(joint_strong$Get_Trace('epsilon')), main = 'with Beta(1,10000) prior', xlab = expression(epsilon), ylab= 'Posterio Density')

FH <-fn_compute_posterior_margins(sampler = FH_imp, cont_object = cont, order = 3, burnin = 10000, steps = 100, points = 50)
DM_weak <- fn_compute_posterior_margins(sampler = joint_weak, cont_object = cont, order = 3, burnin = 10000, steps = 100, points = 50)
DM_strong <- fn_compute_posterior_margins(sampler = joint_strong, cont_object = cont, order = 3, burnin = 10000, steps = 100, points = 50)

#####
# Summaries

x11(10,10); par(mfrow = c(2,2))
x11(10,5); par(mfrow = c(1,2))
m <- max(actual$point, FH$s.noise$point, FH$s.imputed)
scatter_comparison(x = actual$point[nice], y = FH$s.orig$point[nice], m = m, main = 'Three-way margin proportions\n (uncontaminated sample)', ylab = 'Uncontaminated Sample', xlab = 'Population')
scatter_comparison(x = actual$point[nice], y = FH$s.noise$point[nice], m = m, main = 'Three-way margin proportions\n (noisy sample)', ylab = 'Noisy Sample', xlab = 'Population')

scatter_comparison(x = actual$point[nice], y = FH$s.imputed[nice], m = m, main = 'Three-way margin proportions\n (Imputed Sample)', ylab = 'Imputed Sample', xlab = 'Population')
scatter_comparison(x = FH$s.orig$point[nice], y = FH$s.imputed[nice], m = m, main = 'Three-way margin proportions\n (Uncontaminated vs Imputed samples)', ylab = 'Imputed', xlab = 'Uncontaminated')

x11(10,10); par(mfrow = c(2,2))
m <- max(actual$point, DM_weak$s.noise$point, DM$s.imputed)
scatter_comparison(x = actual$point[nice], y = DM_weak$s.orig$point[nice], m = m, main = 'Three-way margin proportions\n (uncontaminated sample)', ylab = 'Uncontaminated Sample', xlab = 'Population')
scatter_comparison(x = actual$point[nice], y = DM_weak$s.noise$point[nice], m = m, main = 'Three-way margin proportions\n (noisy sample)', ylab = 'Noisy Sample', xlab = 'Population')
scatter_comparison(x = actual$point[nice], y = DM_weak$s.imputed[nice], m = m, main = 'Three-way margin proportions\n (Joint Edited-Imputed Sample)', ylab = 'Imputed Sample', xlab = 'Population')
scatter_comparison(x = DM_weak$s.orig$point[nice], y = DM_weak$s.imputed[nice], m = m, main = 'Three-way margin proportions\n (Uncontaminated vs Joint Edited-Imputed samples)', ylab = 'Imputed', xlab = 'Uncontaminated')

x11(10,10); par(mfrow = c(2,2))
m <- max(actual$point, DM_strong$s.noise$point, DM$s.imputed)
scatter_comparison(x = actual$point, y = DM_strong$s.orig$point, m = m, main = 'Three-way margin proportions\n (uncontaminated sample)', ylab = 'Uncontaminated Sample', xlab = 'Population')
scatter_comparison(x = actual$point, y = DM_strong$s.noise$point, m = m, main = 'Three-way margin proportions\n (noisy sample)', ylab = 'Noisy Sample', xlab = 'Population')
scatter_comparison(x = actual$point, y = DM_strong$s.imputed, m = m, main = 'Three-way margin proportions\n (Joint Edited-Imputed Sample)', ylab = 'Imputed Sample', xlab = 'Population')
scatter_comparison(x = DM_strong$s.orig$point, y = DM_strong$s.imputed, m = m, main = 'Three-way margin proportions\n (Uncontaminated vs Joint Edited-Imputed samples)', ylab = 'Imputed', xlab = 'Uncontaminated')

x11(10*0.9,3.8*0.9); par(mfrow = c(1,3))
scatter_comparison(x = actual$point[nice], y = DM_weak$s.imputed[nice], m = m, main = 'JOINT est. vs. Population\n Beta(1,1) prior', ylab = 'Imputed', xlab = 'Population')
scatter_comparison(x = actual$point[nice], y = DM_strong$s.imputed[nice], m = m, main = 'JOINT est. vs. Population\n Beta(1,10000) prior', ylab = 'Imputed', xlab = 'Population')
scatter_comparison(x = actual$point[nice], y = FH$s.imputed[nice], m = m, main = 'F-H est. vs. Population', ylab = 'F-H Imputed', xlab = 'Population')
dev.copy2pdf(file = 'c:/Data/Daniel4/Presentations/IU_Semiar_2014/plots/one_sample_imputations.pdf')

rm(x, FH_imp);gc();
fn_UNLoad_Lcm_Stuff()
